exercises/models/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # BEGIN
  resources :articles, only: [:index, :show]
  # END
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

exercises/models/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/models/app/models/article.rb
class Article < ApplicationRecord
  validates :title, presence: true
  validates :body, presence: true
end

exercises/models/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/models/app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  def index
    @articles = Article.all
  end

  def show
    @article = Article.find(params[:id])
  end
end

exercises/models/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/models/app/helpers/articles_helper.rb
module ArticlesHelper
end

exercises/models/app/views/articles/index.html.erb
<h1>Articles</h1>

<ul>
  <% @articles.each do |article| %>
    <li>
      <%= link_to article.title, article_path(article) %>
    </li>
  <% end %>
</ul>

exercises/models/app/views/articles/shared/_home_link.html.erb
<%= link_to "Articles", articles_path %>

exercises/models/app/views/articles/show.html.erb
<%= render partial: "articles/shared/home_link" %>

<h1><%= @article.title %></h1>

<p><%= @article.body %></p>

exercises/models/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Models</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all' %>
  </head>

  <body class="app">
    <%= yield %>
  </body>
</html>